#1 RFE: Decrypt messages permanently


Bug 1983 migrated from Mozdev.org

Many people like me use encryption to submit messages confidentially, not to
protect them once they are downloaded.

So it would be great if one had the option that messages, when decrypted for the
first time, are then stored decrypted in the mail folders, so that they are
accessible without enigmail after that.

The "save decrypted message" menu entry is inappropriate for this since it saves
messages to external files only.

------- Comment #1 From Patrick Brunschwig 2003-05-30 04:47:56 [reply] -------

Moving the version forwards ... and reducing the priority

------- Comment #2 From Igor Velkov 2005-04-04 07:58:26 [reply] -------

Please, look there https://bugzilla.mozilla.org/show_bug.cgi?id=288700
Maybe, it will help to make this enh real?

------- Comment #3 From Patrick Brunschwig 2005-04-04 08:15:57 [reply] -------

Excuse me, but searching encrypted messages is exactly not permanently
decrpyting. Of course, once a message is permanently decrypted, it can be
searched -- but searching an encrypted message means without decrypting it

I know how to technically save a message, but things are not that simple. In
fact, it's not due to technical difficulties why the feature isn't available but
rather because it's a lot of work to actually implement it.

------- Comment #4 From Jon Perez 2005-04-09 01:15:15 [reply] -------

Indeed I think that a significant percentage of users use Enigmail/PGP solely
protect messages in transit and thus saving the incoming email in encrypted,
unsearchable, form is very inconvenient.

That said, I can appreciate why Mozilla/Thunderbird internals might need to be
hacked in order to save incoming encrypted email as unencrypted.

------- Comment #5 From Igor Velkov 2005-04-09 07:28:23 [reply] -------

(In reply to comment #4)

That said, I can appreciate why Mozilla/Thunderbird internals might need to be
hacked in order to save incoming encrypted email as unencrypted.

I not understand, why any hacks needed. I can't see the differences between
saving decrypted messages and delete attachements. All of this cases need to
read message body, change it on client, then save new message, and delete
original. Bug 288700 is resolved, no more hacks needed.

------- Comment #6 From Jui 2005-04-11 06:10:22 [reply] -------

There is one important thing for haveing an option to save the cleartext
(decrypted) messages once downloaded and encrypted on the users computer. If you
need to archive all emails due to internal or external (government) requirements.
It becomes VERY painfull if you have a lot of encrypted stuff in your company's
email archive when you need to search the archive. In addition search-engines
like Google Desktop will nt be able to find encrypted emails on your computer.
Therefore an option to save the decrypted messages once downloaded and decrypted
by the user permanently in the mail-folder/mail-file is quite important. There
might be several other reasons for that. But why not add an option!


------- Comment #7 From Barry Porter 2005-06-14 14:37:05 [reply] -------

Bug 10705 has been marked as a duplicate of this bug.

------- Comment #8 From mozdev.org@stefan-neufeind.de 2005-06-27 15:00:58 [reply] -------

Any progress on this?

------- Comment #9 From Carsten Krueger 2006-02-23 19:59:38 [reply] -------

please add this feature.
otherwise enigmail is useless if you have many encrypted mails (50 mails in
each direction a day).

look at gpgrelay.sourceforge.net

------- Comment #10 From zerohalo 2007-01-17 09:36:29 [reply] -------

As a daily Enigmail user (thanks, Patrick!), I would like to add my vote for
this feature. The PGP plugin for Outlook does this, and it's a feature I've
much missed since switching to Thunderbird (on Linux). As someone pointed out,
users generally use PGP to protect their emails in transit, and for those who
do want to keep their email encrypted on their computer, generally have their
email folders stored in an encrypted partition along with other private
documents (or could easily do so if they wanted to). So having this feature (at
least as an option) would be a Godsend.

Likewise, I would request, if possible that both the email and the attachments
be stored in plain text. This would allow searching for past emails using the
TBird search (or third-party applications like Beagle), and searching the
attachments themselves using Beagle or Google-Desktop, etc.

I find the lack of this feature a difficult obstacle in trying to convert
people over from Outlook/PGP to Thunderbird/Enigmail, as the inability to
search past emails easily is often a show-stopper.

------- Comment #11 From Carsten Krueger 2007-01-17 10:32:12 [reply] -------

PS: If possible store the messages decrypted but don't destroy the signing

------- Comment #12 From lg 2007-03-13 03:17:51 [reply] -------

The option to save the decrypted messages permanently in the mail-folder is a
major requirement for us. Is this going to be developed soon? We would be happy
to assist with testing.

------- Comment #13 From Matthias 2007-07-04 11:56:29 [reply] -------

In my point of view this feature request deserves a lot more priority!

------- Comment #14 From Stefan Neufeind 2008-10-18 07:37:14 [reply] -------

This is a BLOCKER for wide-spread use of encryption among friends/colleagues of
mine, and me as well.

------- Comment #15 From Marcus 2009-04-24 15:58:32 [reply] -------

Please increase the priority of this request! The lack of this feature is
preventing me from using enigmail, since I am interested in encrypted transit
only (like presumably a lot of other potential users).

I'm in favor of receiving my letters in an envelope but I'm not in favor of
having to store them in a vault. That would be extremely inconvenient.


Forum: Option to cache unencrypted letters
Forum: Option to cache unencrypted letters
Forum: Encrypt existing IMAP boxes
Forum: Make encrypted messages searchable
Forum: Make encrypted messages searchable
Forum: Save mails decrypted?


    • operating_system: Windows --> all
    • fixed_in_version: 1.4.3 --> 0.95.x
  • Johannes

    Just a note for those in need of the feature. There exists a workaround using "gpgrelay", allowing to encrypt and decrypt emails on the fly using some sort of proxy server. This happens totally transparent to the email client, so all mail will be stored unencrypted locally.

  • Robert Pollak
    Robert Pollak

    If I remember correctly, this feature is blocked by necessary Thunderbird changes. Patrick, could you please give a link to the relevant Thunderbird bugzilla entry or entries here, as you did for enigmail bug 2? Is Thunderbird's bug 22687: PGP Plugin the one?

    • Dominik K.
      Dominik K.

      Bug 280588 - Encrypted email messages should be stored decrypted in the local folders

      related to Enigmail's bug 2: Bug 188988 - encrypted emails are not searched

    • Furlong

      I'm just trying to organize a solution to this bug and do a crowdfunding if necessary. But I really need some help, as I'm not a developer. For the first step I would prefer the simplest solution which is an option to overwrite the PGP-part of a message at the first reading with the decrypted text (locally in POP3 mode).
      1. What needs to be done on the thunderbird side?
      2. What needs to be done on the enigmail side?
      3. Anyone knows a mozilla dev who is willing to do this and/or can estimate the costs?
      3. Any whishes/ideas/comments on this?

  • wastefan

    Once every couple of months a stumble upon this bug. This time I ask myself: why can't it be done the following way?:
    1. export decrypted message to a temporary .eml-file (Enigmail can export to text files already)
    2. import this (decrypted) temporary .eml-file to Thunderbird
    3. (optionally) delete encrypted message

    • Robert Pollak
      Robert Pollak

      "Save decrypted message" only works for messages in the PGP/INLINE format, not for PGP/MIME messages.

  • Furlong

    Finally! We just started a crowd funding for the filter action solution. Patrick is open for this way, as he currently does not have time to do it. Any programmers are welcome to work on it.
    If everybody just gives a small amount we can fulfill this ten year old request!

    Last edit: Furlong 2014-01-26
  • Furlong

    I need some help from all of you to make this happen. The crowdfunding is stuck at 570$. Not bad ... but as it seems not enough for a programmer to take the task.

    1. More money. You know someone or a company using OpenPGP? Write him about this. Or spread it to your favorite social media website.
    2. We need a programmer. Does anyone know a javascript developer with some open source experience? As the money is probably not enough for the time invested, I hope for someone with a supporting attitude towards encryption.
    3. Any other ideas?

    Last edit: Furlong 2014-03-05
  • fberger

    This is a total showstopper for Enigmail usage.

    Watching this bug eagerly for updates.

  • A first step in this direction is now made: the latest Enigmail trunk build contains new filter messages that allow to move or copy a decrypted version of the message. This allows to decrypt messages permanently either directly upon arrival or at any later stage.

    The feature is still experimental; I highly recommend to currently only use the "Copy" filter, which creates a decrypted copy of the original encrypted version.

    • status: open --> fixed
    • Found in Version: before_1.4 --> 1.7.2
    • Operating System: --> All
    • Fixed in version: --> 1.8.0
  • The new filter rules will be part of the next Enigmail release. Thanks to Janosch Rux for developing the basis of this feature.

  • It's great that there is a workaround now!
    Are there instructions how to set up a filter that automatically detects every encrypted message, copies a decrypted version in the same folder as the original message and deletes the original message?
    How reliable is this, i.e. how likely will messages be accidentally deleted completely because of filters not working the way they're supposed to?